package enverstest.model;

import java.util.HashMap;
import java.util.Map;

import org.hibernate.envers.Audited;

@Audited
public class Category 
{
	private Long id;
	private String name;
	private String description;
	
	private Map<Item, String> textItem = new HashMap<>();
	
	private Map<Item, Value> categoryItem = new HashMap<>();
	
	Category(){	}

	public Category (String name)
	{
		this.name = name;
	}
	
	public Long getId()
	{
		return id;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setDescription(String description)
	{
		this.description = description;
	}
	
	public String getDescription()
	{
		return description;
	}
	
	public void setName(String name)
	{
		this.name = name;
	}
	
	public Map<Item, Value> getCategoryItem()
	{
		return categoryItem;
	}
	
	public void setValue(Item key, Value value)
	{
		categoryItem.put(key, value);
	}
	
	public Value getValue(Item key)
	{
		return categoryItem.get(key);
	}
	
	public Map<Item, String> getTextItem()
	{
		return textItem;
	}
	
	public void setText(Item key, String value)
	{
		textItem.put(key, value);
	}
	
	public String getText(Item key)
	{
		return textItem.get(key);
	}
}
