package enverstest.model;

import org.hibernate.envers.Audited;

@Audited
public class Item 
{
	private Long id;
	private String name;
	
	Item() {}
	
	public Item(String name)
	{
		this.name = name;
	}
	
	public Long getId()
	{
		return id;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setName(String name)
	{
		this.name = name;
	}

	@Override
	public boolean equals(final Object obj)
	{
        if (obj == this)
            return true;

        if (!(obj instanceof Item))
            return false;
        
        final Item other = (Item)obj;
        
        if (id == null)
        	return other.id == null;
        
        return id.equals(other.id);
	}
	
	@Override
	public int hashCode()
	{
		return (id == 0) ? 0 : id.hashCode();
	}
}
