DROP TABLE category_item_r;
DROP TABLE category_item;
DROP TABLE text_item_r;
DROP TABLE text_item;
DROP TABLE item_r;
DROP TABLE item;
DROP TABLE category_r;
DROP TABLE category;
DROP TABLE revision;

CREATE TABLE category
(
  id serial NOT NULL,
  name VARCHAR(40) NOT NULL,
  description VARCHAR(250)
);

CREATE TABLE category_r
(
  rev_begin INTEGER NOT NULL,
  rev_end INTEGER,
  rev_type SMALLINT NOT NULL,
  id INTEGER NOT NULL,
  name VARCHAR(40),
  description VARCHAR(250)
);

CREATE TABLE item
(
  id serial NOT NULL,
  name VARCHAR(40) NOT NULL
);

CREATE TABLE item_r
(
  rev_begin INTEGER NOT NULL,
  rev_end INTEGER,
  rev_type SMALLINT NOT NULL,
  id INTEGER NOT NULL,
  name VARCHAR(40)
);

CREATE TABLE category_item
(
  category_id INTEGER NOT NULL,
  item_id INTEGER NOT NULL,
  number INTEGER,
  text TEXT
);

CREATE TABLE category_item_r
(
  rev_begin INTEGER NOT NULL,
  rev_end INTEGER,
  rev_type SMALLINT NOT NULL,
  category_id INTEGER NOT NULL,
  item_id INTEGER NOT NULL,
  number INTEGER,
  text TEXT
);

CREATE TABLE text_item
(
  category_id INTEGER NOT NULL,
  item_id INTEGER NOT NULL,
  text TEXT
);

CREATE TABLE text_item_r
(
  rev_begin INTEGER NOT NULL,
  rev_end INTEGER,
  rev_type SMALLINT NOT NULL,
  category_id INTEGER NOT NULL,
  item_id INTEGER NOT NULL,
  text TEXT
);

CREATE TABLE revision
(
  id serial NOT NULL,
  ts BIGINT NOT NULL
);

ALTER TABLE revision
  ADD CONSTRAINT pk_revision
  PRIMARY KEY (id);

ALTER TABLE category
  ADD CONSTRAINT pk_category
  PRIMARY KEY (id);

ALTER TABLE category_r
  ADD CONSTRAINT pk_category_r
  PRIMARY KEY (id,rev_begin);

ALTER TABLE category_r
  ADD CONSTRAINT fk_category_r_rev_begin
  FOREIGN KEY (rev_begin) REFERENCES revision(id);
  
ALTER TABLE category_r
  ADD CONSTRAINT fk_category_r_rev_end
  FOREIGN KEY (rev_end) REFERENCES revision(id);
  
ALTER TABLE item
  ADD CONSTRAINT pk_item
  PRIMARY KEY (id);

ALTER TABLE item_r
  ADD CONSTRAINT pk_item_r
  PRIMARY KEY (id,rev_begin);

ALTER TABLE item_r
  ADD CONSTRAINT fk_item_r_rev_begin
  FOREIGN KEY (rev_begin) REFERENCES revision(id);
  
ALTER TABLE item_r
  ADD CONSTRAINT fk_item_r_rev_end
  FOREIGN KEY (rev_end) REFERENCES revision(id);
  
ALTER TABLE category_item
  ADD CONSTRAINT pk_category_item
  PRIMARY KEY (category_id, item_id);
  
ALTER TABLE category_item
  ADD CONSTRAINT fk_category_item_category
  FOREIGN KEY(category_id)
  REFERENCES category(id);

ALTER TABLE category_item
  ADD CONSTRAINT fk_category_item_item
  FOREIGN KEY(item_id)
  REFERENCES item(id);
  
ALTER TABLE category_item_r
  ADD CONSTRAINT fk_category_item_r_rev_begin
  FOREIGN KEY (rev_begin) REFERENCES revision(id);
  
ALTER TABLE category_item_r
  ADD CONSTRAINT fk_category_item_r_rev_end
  FOREIGN KEY (rev_end) REFERENCES revision(id);

ALTER TABLE text_item
  ADD CONSTRAINT pk_text_item
  PRIMARY KEY (category_id, item_id);
  
ALTER TABLE text_item
  ADD CONSTRAINT fk_text_item_category
  FOREIGN KEY(category_id)
  REFERENCES category(id);

ALTER TABLE text_item
  ADD CONSTRAINT fk_text_item_item
  FOREIGN KEY(item_id)
  REFERENCES item(id);
  
ALTER TABLE text_item_r
  ADD CONSTRAINT fk_text_item_r_rev_begin
  FOREIGN KEY (rev_begin) REFERENCES revision(id);
  
ALTER TABLE text_item_r
  ADD CONSTRAINT fk_text_item_r_rev_end
  FOREIGN KEY (rev_end) REFERENCES revision(id);
  